public inbox for gentoo-commits@lists.gentoo.org
 help / color / mirror / Atom feed
From: "Benda XU" <heroxbd@gentoo.org>
To: gentoo-commits@lists.gentoo.org
Subject: [gentoo-commits] dev/heroxbd:master commit in: eclass/
Date: Thu, 26 May 2016 04:04:06 +0000 (UTC)	[thread overview]
Message-ID: <1464235431.e3dbf227fb7126e54e7b151aac2ec4feffff5e24.heroxbd@gentoo> (raw)
Message-ID: <20160526040406.wVcXXM_WN6ftVOGsYJZRIW-LyXueA2ChRylgWyPNuPs@z> (raw)

commit:     e3dbf227fb7126e54e7b151aac2ec4feffff5e24
Author:     Benda Xu <heroxbd <AT> gentoo <DOT> org>
AuthorDate: Thu May 26 04:03:51 2016 +0000
Commit:     Benda XU <heroxbd <AT> gentoo <DOT> org>
CommitDate: Thu May 26 04:03:51 2016 +0000
URL:        https://gitweb.gentoo.org/dev/heroxbd.git/commit/?id=e3dbf227

db.eclass: import from prefix tree.

 eclass/db.eclass | 210 +++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 210 insertions(+)

diff --git a/eclass/db.eclass b/eclass/db.eclass
new file mode 100644
index 0000000..f7070d4
--- /dev/null
+++ b/eclass/db.eclass
@@ -0,0 +1,210 @@
+# Copyright 1999-2013 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/eclass/db.eclass,v 1.49 2013/07/21 09:23:45 pacho Exp $
+# This is a common location for functions used in the sys-libs/db ebuilds
+#
+# Bugs: maintainer-needed@gentoo.org
+
+inherit eutils multilib
+
+IUSE="doc test examples"
+
+EXPORT_FUNCTIONS src_test
+
+DEPEND="test? ( >=dev-lang/tcl-8.4 )"
+
+RDEPEND=""
+
+db_fix_so() {
+	has "${EAPI:-0}" 0 1 2 && ! use prefix && EROOT="${ROOT}"
+	LIB="${EROOT}/usr/$(get_libdir)"
+
+	cd "${LIB}"
+
+	# first clean up old symlinks
+	find "${LIB}" -maxdepth 1 -type l -name 'libdb[1_-]*'"$(get_libname)" -delete
+	find "${LIB}" -maxdepth 1 -type l -name 'libdb[1_-]*'"$(get_libname "[23]")" -delete
+	find "${LIB}" -maxdepth 1 -type l -name "libdb$(get_libname)" -delete #519364
+	find "${LIB}" -maxdepth 1 -type l -name "libdb$(get_libname "[23]")" -delete #519364
+	find "${LIB}" -maxdepth 1 -type l -name 'libdb[1._-]*a' -delete
+
+	# now rebuild all the correct ones
+	for ext in so a dylib sl; do
+		for name in libdb libdb_{cxx,tcl,java,sql,stl}; do
+			target=`find . -maxdepth 1 -type f -name "${name}-*.${ext}" |sort -n |tail -n 1`
+			[ -n "${target}" ] || continue;
+			case ${CHOST} in 
+			*-aix*)
+				aixdll --merge-runtime \
+					--keepdir=false \
+					--target="${name}.${ext}" \
+					--current="${target}" \
+					`find . -maxdepth 1 -type f -name "${name}-*.${ext}"`
+				;;
+			*)
+				ln -sf ${target//.\//} ${name}.${ext}
+				;;
+			esac;
+		done;
+	done;
+
+	# db[23] gets some extra-special stuff
+	if [ -f libdb1$(get_libname 2) ]; then
+		ln -sf libdb1$(get_libname 2) libdb$(get_libname 2)
+		ln -sf libdb1$(get_libname 2) libdb1$(get_libname)
+		ln -sf libdb1$(get_libname 2) libdb-1$(get_libame)
+	fi
+	# what do we do if we ever get 3.3 ?
+	for i in libdb libdb_{cxx,tcl,java,sql,stl}; do
+		if [ -f $i-3$(get_libname 2) ]; then
+			ln -sf $i-3$(get_libname 2) $i-3$(get_libname)
+			ln -sf $i-3$(get_libname 2) $i$(get_libname 3)
+		fi
+	done
+
+	# do the same for headers now
+	# but since there are only two of them, just overwrite them
+	cd "${EROOT}"/usr/include
+	target=`find . -maxdepth 1 -type d -name 'db[0-9]*' | sort -n |cut -d/ -f2- | tail -n1`
+	if [ -n "${target}" ] && [ -e "${target}/db.h" ] && ( ! [[ -e db.h ]] || [[ -h db.h ]] ); then
+		einfo "Creating db.h symlinks to ${target}"
+		ln -sf "${target}"/db.h .
+		ln -sf "${target}"/db_185.h .
+	elif [ ! -e "${target}/db.h" ]; then
+		if [ -n "${target}" ]; then
+			ewarn "Could not find ${target}/db.h"
+		elif [ -h db.h ]; then
+			einfo "Apparently you just removed the last instance of $PN. Removing the symlinks"
+			rm -f db.h db_185.h
+		fi
+	fi
+}
+
+db_src_install_doc() {
+	has "${EAPI:-0}" 0 1 2 && ! use prefix && ED="${D}"
+	# not everybody wants this wad of documentation as it is primarily API docs
+	if use doc; then
+		dodir /usr/share/doc/${PF}/html
+		mv "${ED}"/usr/docs/* "${ED}"/usr/share/doc/${PF}/html/
+		rm -rf "${ED}"/usr/docs
+	else
+		rm -rf "${ED}"/usr/docs
+	fi
+
+	db_src_install_examples
+}
+
+db_src_install_examples() {
+	has "${EAPI:-0}" 0 1 2 && ! use prefix && ED="${D}"
+	if use examples ; then
+		local langs="c cxx stl"
+		[[ "${IUSE/java}" != "${IUSE}" ]] \
+			&& use java \
+			&& langs="${langs} java"
+		for i in $langs ; do
+			destdir="/usr/share/doc/${PF}/"
+			src="${S}/../examples_${i}/"
+			if [ -f "${src}" ]; then
+				dodir "${destdir}"
+				cp -ra "${src}" "${ED}${destdir}/"
+			fi
+		done
+	fi
+}
+
+db_src_install_usrbinslot() {
+	has "${EAPI:-0}" 0 1 2 && ! use prefix && ED="${D}"
+	# slot all program names to avoid overwriting
+	for fname in "${ED}"/usr/bin/db*
+	do
+		dn="$(dirname "${fname}")"
+		bn="$(basename "${fname}")"
+		bn="${bn/db/db${SLOT}}"
+		mv "${fname}" "${dn}/${bn}" || \
+			die "Failed to rename ${fname} to ${dn}/${bn}"
+	done
+}
+
+db_src_install_headerslot() {
+	has "${EAPI:-0}" 0 1 2 && ! use prefix && ED="${D}"
+	# install all headers in a slotted location
+	dodir /usr/include/db${SLOT}
+	mv "${ED}"/usr/include/*.h "${ED}"/usr/include/db${SLOT}/
+}
+
+db_src_install_usrlibcleanup() {
+	has "${EAPI:-0}" 0 1 2 && ! use prefix && ED="${D}"
+	LIB="${ED}/usr/$(get_libdir)"
+	# Clean out the symlinks so that they will not be recorded in the
+	# contents (bug #60732)
+
+	if [ "${ED}" = "" ]; then
+		die "Calling clean_links while \$ED not defined"
+	fi
+
+	if [ -e "${LIB}"/libdb.a ] && [ ! -e "${LIB}"/libdb-${SLOT}.a ]; then
+		einfo "Moving libdb.a to a versioned name"
+		mv "${LIB}/libdb.a" "${LIB}/libdb-${SLOT}.a"
+	fi
+
+	if [ -e "${LIB}"/libdb_cxx.a ] && [ ! -e "${LIB}"/libdb_cxx-${SLOT}.a ]; then
+		einfo "Moving libdb_cxx.a to a versioned name"
+		mv "${LIB}/libdb_cxx.a" "${LIB}/libdb_cxx-${SLOT}.a"
+	fi
+
+	find "${LIB}" -maxdepth 1 -type l -name 'libdb[1_-]*'"$(get_libname)" -delete
+	find "${LIB}" -maxdepth 1 -type l -name 'libdb[1_-]*'"$(get_libname "[23]")" -delete
+	find "${LIB}" -maxdepth 1 -type l -name "libdb$(get_libname)" -delete #519364
+	find "${LIB}" -maxdepth 1 -type l -name "libdb$(get_libname "[23]")" -delete #519364
+	einfo "removing unversioned static archives"
+	find "${LIB}" -maxdepth 1 -type l -name 'libdb[1._-]*a' -delete
+
+	rm -f \
+		"${ED}"/usr/include/{db,db_185}.h \
+		"${LIB}"/libdb{,_{cxx,sql,stl,java,tcl}}.a
+}
+
+db_src_test() {
+	if [[ $UID -eq 0 ]]; then
+		M="You must run the testsuite as non-root, skipping"
+		ewarn "${M}"
+		elog "${M}"
+		return 0
+	fi
+
+	if use tcl; then
+		einfo "Running sys-libs/db testsuite"
+		ewarn "This can take 6+ hours on modern machines"
+		# Fix stuff that fails with relative paths, and upstream moving files
+		# around...
+		local test_parallel=''
+		for t in \
+			"${S}"/test/parallel.tcl \
+			"${S}"/../test/parallel.tcl \
+			"${S}"/test/tcl/parallel.tcl \
+			"${S}"/../test/tcl/parallel.tcl \
+			; do
+			[[ -f "${t}" ]] && test_parallel="${t}" && break
+		done
+
+		sed -ri \
+			-e '/regsub .test_path ./s,(regsub),#\1,g' \
+			-e '/regsub .src_root ./s,(regsub),#\1,g' \
+			-e '/regsub .tcl_utils ./s,(regsub),#\1,g' \
+			"${test_parallel}"
+		cd "${S}"
+		for t in \
+			../test/test.tcl \
+			../test/tcl/test.tcl \
+			; do
+			[[ -f "${t}" ]] && testbase="${t}" && break
+		done
+		echo "source ${t}" > testrunner.tcl
+		echo "run_parallel $(makeopts_jobs) run_std" >> testrunner.tcl
+
+		tclsh testrunner.tcl
+		egrep -qs '^FAIL' ALL.OUT* && die "Some tests failed, please see ${S}/ALL.OUT*"
+	else
+		eerror "You must have USE=tcl to run the sys-libs/db testsuite."
+	fi
+}


             reply	other threads:[~2016-05-26  4:04 UTC|newest]

Thread overview: 21+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2016-05-26  4:05 Benda XU [this message]
2016-05-26  4:04 ` [gentoo-commits] dev/heroxbd:master commit in: eclass/ Benda XU
  -- strict thread matches above, loose matches on Subject: below --
2017-11-27  1:09 [gentoo-commits] proj/android:master " Benda XU
2017-08-30  9:22 Benda XU
2017-08-07  6:12 Benda XU
2017-02-09  4:52 Benda XU
2017-01-07 14:29 Benda XU
2016-10-24 12:30 Benda XU
2016-07-21 12:38 Benda XU
2016-07-21  2:23 [gentoo-commits] dev/heroxbd:master " Benda XU
2016-07-21  2:19 ` [gentoo-commits] proj/android:master " Benda XU
2016-07-21  2:19 Benda XU
2016-06-24  3:07 Benda XU
2016-06-15 11:40 Benda XU
2016-06-15 10:56 Benda XU
2016-06-14  2:00 Benda XU
2016-06-07 10:48 Benda XU
2016-05-26  4:05 Benda XU
2016-05-26  4:05 Benda XU
2016-05-26  4:05 Benda XU
2016-05-23 16:15 [gentoo-commits] dev/heroxbd:master " Benda XU
2016-05-26  4:05 ` [gentoo-commits] proj/android:master " Benda XU
2016-05-23  6:18 [gentoo-commits] dev/heroxbd:master " Benda XU
2016-05-26  4:05 ` [gentoo-commits] proj/android:master " Benda XU

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1464235431.e3dbf227fb7126e54e7b151aac2ec4feffff5e24.heroxbd@gentoo \
    --to=heroxbd@gentoo.org \
    --cc=gentoo-commits@lists.gentoo.org \
    --cc=gentoo-dev@lists.gentoo.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox